﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Data.Spatial;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace EF_Sample_CodeFirst
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Database.SetInitializer<SampleContext>(new DropCreateDatabaseIfModelChanges<SampleContext>());
            cbxFamily.Items.Add(Familienstatus.Lebenspartnerschaft);
            cbxFamily.Items.Add(Familienstatus.Ledig);
            cbxFamily.Items.Add(Familienstatus.Verheiratet);
            cbxFamily.Items.Add(Familienstatus.Verwitwet);
            cbxFamily.SelectedIndex = 0;

            cbxGender.Items.Add(Gender.Male);
            cbxGender.Items.Add(Gender.Female);
            cbxGender.SelectedIndex = 0;

        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            using (SampleContext context = new SampleContext())
            {
                Person p = new Person();
                int adressId = int.Parse(txtLive.Text);
                p.Arbeitsort = context.Adressen.First(a => a.Id == adressId);
                adressId = int.Parse(txtWork.Text);
                p.Wohnort = context.Adressen.First(a => a.Id == adressId);
                p.Name = txtName.Text;

                Familienstatus status = Familienstatus.Ledig;

                foreach (var item in cbxFamily.SelectedItems)
                {
                    status = status | (Familienstatus)item;
                }

                p.Familienstatus = status;
                p.Geschlecht = (Gender)cbxGender.SelectedItem;
                context.Personen.Add(p);
                context.SaveChanges();
                MessageBox.Show(p.Id.ToString());
            }
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            using (SampleContext context = new SampleContext())
            {

                Adresse a = new Adresse();
                a.GeographyLocation = DbGeography.FromText(string.Format("POINT({0} {1})", txtLat.Text, txtLong.Text));
                a.GeometryLocation = DbGeometry.FromText(string.Format("POINT({0} {1})", txtLat.Text, txtLong.Text));
                context.Adressen.Add(a);
                context.SaveChanges();
                MessageBox.Show(a.Id.ToString());
            }
        }
    }
}
