﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Threading;

namespace StaticPropertyBindingSample
{
    public static class Zeitgeber
    {
        private static DispatcherTimer timer;


        public static event EventHandler<PropertyChangedEventArgs> StaticPropertyChanged;
        public static void RaiseStaticPropertyChanged([CallerMemberName]string propName = "")
        {
            if (StaticPropertyChanged != null)
                StaticPropertyChanged(null, new PropertyChangedEventArgs(propName));
        }



        private static DateTime _zeit;
        public static DateTime Zeit
        {
            get { return _zeit; }
            set
            {
                _zeit = value;
                RaiseStaticPropertyChanged();
            }
        }

        static Zeitgeber()
        {
            timer = new DispatcherTimer(TimeSpan.FromSeconds(1), DispatcherPriority.Normal, (s, e) => { Zeit = DateTime.Now; }, Dispatcher.CurrentDispatcher);
            timer.Start();

        }

    }
}
