﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace tps_sample
{
    /// <summary>
    /// Interaction logic for ReductionSample.xaml
    /// </summary>
    public partial class ReductionSample : UserControl
    {
        public ReductionSample()
        {
            InitializeComponent();
        }

        private async void Button_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                string[] parts = txtValues.Text.Split(' ');
                var ints = parts.Select(p => int.Parse(p));
                int result = await Square(ints);
                txtResult.Text = result.ToString();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), ex.Message);
            }
        }

        private async Task<int> Square(IEnumerable<int> ints)
        {
            return await Task.Run<int>(() =>
            {
                var resources = new ThreadLocal<int>(() => 0, trackAllValues: true);

                var tasks = ints
                    .Select(i => Task.Run(() =>
                    {
                        Thread.Sleep(2000);
                        resources.Value = i * i;
                    }))
                    .ToArray();

                Task.WaitAll(tasks);

                return resources.Values.Sum();
            });
        }
    }
}
